
// Command controller for NoteTaker commands

var notetaker = {
  _cmds : { "notetaker-open-dialog":true,
            "notetaker-close-dialog":true,
            "notetaker-save":true,
            "notetaker-delete":true,
            "notetaker-nav-edit":true,
            "notetaker-nav-keywords":true
          },
  supportsCommand  : function (cmd) { return (cmd in this._cmds); },
  isCommandEnabled : function (cmd) { return true; },
  doCommand        : function (cmd) { return action(cmd); }
};

// Catch-all controller for other commands

var detective = {
  supportsCommand  : function (cmd) { return true; },
  isCommandEnabled : function (cmd) { return true; },
  doCommand        : function (cmd) {
    throw("NoteTaker detective called on command: " + cmd);
    return true;
  }
};

// Installation

function install_controllers()
{
  window.controllers.appendController(notetaker);
  window.controllers.appendController(detective);
}

install_controllers();

// Runtime execution

function execute(cmd)
{
  window.focus();
  try {
    var disp = window.document.commandDispatcher;
    var ctrl = disp.getControllerForCommand(cmd);
    ctrl.doCommand(cmd);
  }
  catch (e) {
    throw (" Command Unknown: " + cmd + ". Error: " + e);
  }
  window.focus();
}

