
window.addEventListener("load",init_toolbar, true);

// all actions for the toolbar window

// The action() function needs cleanup and restructuring
// of its variables. What's here works for teaching
// but could be better structured from the point of
// view of software engineering.

function action(task)
{
  var ns = "http://www.mozilla.org/notetaker-rdf#";

  var rdf = Cc["@mozilla.org/rdf/rdf-service;1"];
      rdf = rdf.getService(Ci.nsIRDFService);

  var container = Cc["@mozilla.org/rdf/container;1"];
      container = container.getService(Ci.nsIRDFContainer);

  var url_node;

  if ( task == "notetaker-open-dialog" )
  {
    window.openDialog("chrome://notetaker/content/editDialog.xul","_blank","modal=yes");
    refresh_toolbar();
  }

  if ( task == "notetaker-display" )
  {
    display_note();
  }

  if ( task == "notetaker-save" )
  {
    var summary = document.getElementById("notetaker-toolbar.summary");
    var keyword = document.getElementById("notetaker-toolbar.keywords");

    var update_type = null;

    if ( note.url != null )
    {
      url_node = rdf.GetResource(note.url);
      if ( keyword.value != "" || summary.value != note.summary )
      {
        update_type = "partial"; // existing note: update summary, keywords
      }
    }
    else if ( window.content && window.content.document
         && window.content.document.visited )
    {
      update_type = "complete"; // a new note
      url_node = window.content.document.location.href;
      url_node = url_node.replace(/\?.*/,""); // toolbar chops any query
      url_node = rdf.GetResource(url_node);
    }
    else
      return;   // not a page that supports notes

    if ( update_type == "complete" )
    {

      // add the note's url to the note container
      var note_cont = rdf.GetResource("urn:notetaker:notes");
      container.Init(noteSession.datasource,note_cont);
      container.AppendElement(url_node);

      // add the note's fields, except for keywords
      var names = ["details", "top", "left", "width", "height"];
      var prop_node, value_node;

      for (var i=0; i < names.length; i++)
      {
        prop_node  = rdf.GetResource(ns + names[i]);
        value_node = rdf.GetLiteral(note[names[i]]);
        noteSession.datasource.Assert(url_node, prop_node, value_node, true);
      }
    }

    if ( update_type != null) 
    {
      // update/add the summary
      var summary_pred = rdf.GetResource(ns + "summary");
      var summary_node = rdf.GetLiteral(summary.value);
      noteSession.datasource.Assert(url_node, summary_pred, summary_node, true);

      // begin work on a single new keyword
      var keyword_node = rdf.GetResource("urn:notetaker:keyword:" + keyword.value);
      var keyword_value = rdf.GetLiteral(keyword.value);

      // make this keyword related to one other keyword for this note
      var keyword_pred = rdf.GetResource(ns + "keyword");
      var related_pred = rdf.GetResource(ns + "related");
      var keyword2 = noteSession.datasource.GetTarget(url_node, keyword_pred, true);
      if (keyword2)
        noteSession.datasource.Assert(keyword_node, related_pred, keyword2, true);

      // add the keyword to this note
      noteSession.datasource.Assert(url_node, keyword_pred, keyword_node, true);

      // state the keyword itself
      var label_pred   = rdf.GetResource(ns + "label");
      noteSession.datasource.Assert(keyword_node, label_pred, keyword_value, true);

      // add the keyword to the container holding all keywords
      var keyword_cont = rdf.GetResource("urn:notetaker:keywords");
      container.Init(noteSession.datasource,keyword_cont);
      container.AppendElement(keyword_node);
    }

    // write it out
    noteSession.datasource.QueryInterface(Ci.nsIRDFRemoteDataSource).Flush();

    note.resolve(url_node.Value);
    display_note();
  }
  if ( task == "notetaker-delete" )
  {
    // Code hacked in place temporarily as a guide; not discussed in
    // the book and hardly tested here. First, bail out if no note exists.

    if ( note.url != null )
      url_node = rdf.GetResource(note.url);
    else
      return;

    // Hard part: keyword facts

    var keyword_predD = rdf.GetResource(ns + "keyword");
    var related_predD = rdf.GetResource(ns + "related");
    var label_predD = rdf.GetResource(ns + "label");
    var keyword_nodeD;
    var keyword_valueD;
    var keyword2;
    var enumkwD, enumUrlD, enumRelD, enumUrl2D;
    var dsD = noteSession.datasource;

    // examine each keyword in the note in turn.

    enumkwD = ds.GetTargets(url_node,keyword_predD,true);

    while (enumkwD.hasMoreElements() )
    {
      keyword_nodeD = enumkwD.getNext().QueryInterface(Ci.nsIRDFNode);
      // If a keyword appears nowhere but in this note,
      // it can be deleted entirely. Check for other notes with this keyword
      enumUrlD = ds.GetSources(keyword_predD,keyword_nodeD,true);
      if (enumUrlD.getNext() && !enumUrlD.hasMoreElements())
      {
        // No other notes, delete the keyword fact.
        keyword_valueD = ds.Unassert(keyword_nodeD,keyword_predD,keyword_valueD,true);

        // delete all facts relating this keyword to another.
        enumRelD = ds.GetTargets(keyword_nodeD, keyword_relatedD,true);
        while (enumRelD.hasMoreElements())
        {
          keyword2 = enumRelD.getNext();
          ds.Unassert(keyword_nodeD, keyword_relatedD, keyword2, true);
        }

        // delete all facts relating another keyword to this keyword
        enumRelD = ds.GetSources(keyword_relatedD, keyword_nodeD,true);
        while (enumRelD.hasMoreElements())
        {
          keyword2 = enumRelD.getNext();
          ds.Unassert(keyword2, keyword_relatedD, keyword_nodeD, true);
        }
      }
      else
      {
        // other notes use this keyword. keep the keyword fact.

        // delete all facts relating this keyword to another
        // where the other keyword is a member of the note
        // to be deleted, but not a member of any other note.
        // .. you get the idea by now, hopefully ...

        // delete all facts relating this keyword to another.
        enumRelD = ds.GetTargets(keyword_nodeD, keyword_relatedD,true);
        while (enumRelD.hasMoreElements())
        {
          keyword2 = enumRelD.getNext();
          enumUrl2D = ds.GetSources(keyword_predD, keyword2, true);
          if (enumUrl2D.getNext() && !enumUrl2D.hasMoreElements())
            ds.Unassert(keyword_nodeD, keyword_relatedD, keyword2, true);
        }

        // delete all facts relating another keyword to this keyword
        enumRelD = ds.GetSources(keyword_relatedD, keyword_nodeD,true);
        while (enumRelD.hasMoreElements())
        {
          keyword2 = enumRelD.getNext();
          enumUrl2D = ds.GetSources(keyword_predD, keyword2, true);
          if (enumUrl2D.getNext() && !enumUrl2D.hasMoreElements())
            ds.Unassert(keyword2, keyword_relatedD, keyword_nodeD, true);
        }
      }
    }

    // Easy part: non-keyword parts of the note

    // remove the note's url from the note container
    var note_contD = rdf.GetResource("urn:notetaker:notes");
    container.Init(noteSession.datasource, note_contD);
    container.RemoveElement(url_node,true);

    // remove the note's fields, except for keywords (already done)
    var namesD = ["summary", "details", "top", "left", "width", "height"];
    var prop_nodeD, value_nodeD;

    for (var i=0; i < namesD.length; i++)
    {
      prop_node  = rdf.GetResource(ns + namesD[i]);
      value_node = rdf.GetLiteral(note[namesD[i]]);
      ds.Unassert(url_node, prop_nodeD, value_nodeD, true);
    }

    note.datasource.QueryInterface(Ci.nsIRDFRemoteDataSource).Flush();
    undisplay_note();
    refresh_toolbar();

    // end of notetaker-delete
  }
  // end of action()
}


// draw a note on an existing HTML page
function display_note()
{
  var style = generate_style();
  var html = generate_html();
  var doc = window.content.document;

  var stree = doc.getElementById("notetaker-styles");
  if ( !stree )		// add the topmost <style>
  {
     stree = doc.createElement("style");
     stree.setAttribute("id","notetaker-styles");
     var head = doc.getElementsByTagName('head').item(0);
     head.appendChild(stree);
  }
  stree.innerHTML = style;

  var htree = doc.getElementById("notetaker-note");
  if ( !htree )		// add the topmost <span>
  {
    htree = doc.createElement("span");
    htree.setAttribute("id","notetaker-note");
    var body = doc.getElementsByTagName('body').item(0);
    body.appendChild(htree);
  }
  htree.innerHTML = html;
}

function undisplay_note()
{
  var doc = window.content.document;
  var element = doc.getElementById("notetaker-note");
  var parent = element.parentNode;
  parent.removeChild(element);
}

// populate the HTML content of the note with data and return it
function generate_html()
{
  var source = '<span id="notetaker-note-summary">{summary}</span>' +
               '<span id="notetaker-note-details">{details}</span>';

  source = source.replace(/\{summary\}/, note.summary);
  source = source.replace(/\{details\}/, note.details);

  return source;
}

// populate the HTML content of the note with data and return it
function generate_style()
{
  var source = "#notetaker-note {" + 
    "display:block; position:absolute; z-index:2147483646; overflow:auto;" + 
    "background-color:lightyellow; border:solid; border-color:yellow;"  + 
    "width:{width}px; height:{height}px; top:{top}px; left:{left}px; }\n" + 

    "#notetaker-note-summary { display:block; font-weight:bold; }\n" + 

    "#notetaker-note-details { display:block; margin-top:5px; }\n";

  source = source.replace(/\{width\}/, note.width);
  source = source.replace(/\{height\}/, note.height);
  source = source.replace(/\{top\}/, note.top);
  source = source.replace(/\{left\}/, note.left);

  return source;
}

// display the note as soon as there's content

function content_poll()
{
  var doc;
  try {
    if ( !window.content ) throw('fail');
    doc = window.content.document;
    if ( !doc ) throw('fail');
    if ( doc.getElementsByTagName("body").length == 0 ) throw('fail');
    if ( doc.location.href == "about:blank" ) throw('fail');
  }
  catch (e) {
    note.clear();
    refresh_toolbar();
    return;
  }
  
  if ( doc.visited ) return;

  note.resolve(doc.location.href);
  if (note.url != null )
    display_note();

  refresh_toolbar();
  doc.visited = true;
}

function init_toolbar(origin)
{
  if ( origin != "timed" ) {
    // avoid running inside any onload handler
    setTimeout("init_toolbar('timed')",1);
  }
  else
  {
    var menu = window.document.getElementById('notetaker-toolbar.keywords');
    menu.database.AddDataSource(noteSession.datasource);
    menu.ref = 'urn:notetaker:keywords';
    setInterval("content_poll()", 1000);
  }
}

function refresh_toolbar()
{
  var box = document.getElementById('notetaker-toolbar.summary');
  box.value = note.summary;

  var menu = document.getElementById('notetaker-toolbar.keywords');
  menu.ref = 'urn:notetaker:keywords';
}
